//
//  IPhoneDeviceManager.h
//  VclustersGemini
//
//  Created by APPLE on 2019/6/14.
//  Copyright © 2019 APPLE. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface iPhone : NSObject

#pragma mark 手机相关参数
/**
 * @brief 手机管理对象单列
 *
 */
+ (iPhone *)shareInstance;

/**
 * @brief 获取手机IP地址
 *
 */
+ (NSString*)phoneDeviceIPAddress;

/**
 * @brief 获取手机UUID
 *
 */
+ (NSString*)phoneDeviceUuid;

/**
 * @brief 获取手机类别
 *
 */
+ (NSString*)phoneDeviceType;

/**
* @brief 获取app版本号
*
*/
+ (NSString*)appVersion;

/**
* @brief 获取手机操作系统版本号
*
*/
+ (NSString*)phoneVersion;

/**
* @brief 应用名称
*
*/
+ (NSString*)appBundleName;

/**
* @brief 获取手机分辨率
*
*/
+ (NSString *)resolution;

#pragma mark 验证邮箱格式
/**
* @brief 判断邮箱是否为合法邮箱格式  不判断邮箱是否存在仅判断格式是否正确
*
*/
+ (BOOL)validateEmail:(NSString *)email;

#pragma mark 验证手机号码是否有效
/**
* @brief 判断手机号码是否有效  针对中国大陆手机号码 省略区号
*
*/
+ (BOOL)isVaildPhoneNo:(NSString *)mobileNum;

#pragma mark 验证身份证号码
/**验证身份证*/
+ (BOOL)verifyIDCardNumber:(NSString *)value;

#pragma mark 获取运营商名称
/**获取运营商名称*/
+ (NSString *)getCarrierInfo;

@end

NS_ASSUME_NONNULL_END
