//
//  UIView+HWCategory.h
//  YidaHealth
//
//  Created by 余衡武 on 2018/9/20.
//  Copyright © 2018年 余衡武. All rights reserved.
//

#import <UIKit/UIKit.h>

NS_ASSUME_NONNULL_BEGIN


//=============================================================================//
//  UIView
//=============================================================================//
@interface UIView (HWCategory)

@property (assign, nonatomic) CGFloat hw_x;                 /**< 原点x*/
@property (assign, nonatomic) CGFloat hw_y;                 /**< 原点y*/
@property (assign, nonatomic) CGFloat hw_w;                 /**< 宽度w*/
@property (assign, nonatomic) CGFloat hw_h;                 /**< 高度h*/

@property (assign, nonatomic) CGFloat hw_center_x;          /**< 中心点x*/
@property (assign, nonatomic) CGFloat hw_center_y;          /**< 中心点y*/

@property (assign, nonatomic) CGPoint hw_origin;            /**< 原点*/
@property (assign, nonatomic) CGSize  hw_size;              /**< 大小*/

@property (assign, nonatomic, readonly) CGFloat hw_max_x;   /**< 原点x + 宽度w*/
@property (assign, nonatomic, readonly) CGFloat hw_max_y;   /**< 原点y + 宽度h*/

- (UIView*)subViewOfClassName:(NSString*)className;

/**
 设置圆角

 @param cornerSize 圆角的大小
 @param type 圆角的类型
 */
- (void)roundCornerRect:(CGSize)cornerSize type:(UIRectCorner)type;

@end

//=============================================================================//
//  UIColor
//=============================================================================//
@interface UIColor (HWCategory)
+ (UIColor *)hwColor:(id)object;
+ (UIColor *)hwColor:(id)object alpha:(CGFloat)dAlpha;/*颜色设置 可调整透明度*/
@end

//=============================================================================//
//  UIButton
//=============================================================================//
@interface UIButton (HWCategory)

- (UIButton *(^)(id))hw_imageUpTitleDown;

@end


NS_ASSUME_NONNULL_END
