//
//  AJPhotoGroupView.h
//  AJPhotoPicker
//
//  Created by AlienJunX on 15/11/2.
//  Copyright (c) 2015 AlienJunX
//
//  This source code is licensed under the MIT-style license found in the
//  LICENSE file in the root directory of this source tree.
//

#import <UIKit/UIKit.h>
#import <Photos/Photos.h>
#import "TZImageManager.h"

@class ALAssetsGroup;
@class ALAssetsFilter;


@protocol AJPhotoGroupViewProtocol <NSObject>

/**
 *  选中相册
 *
 *  @param model 相册
 */
- (void)didSelectGroup:(TZAlbumModel *)model;

@end


@interface AJPhotoGroupView : UITableView
//委托
@property (weak, nonatomic) id<AJPhotoGroupViewProtocol> my_delegate;

@property (nonatomic,assign) BOOL isPhotoType;//是否为选择图片类型

//选中相册的索引
@property (nonatomic) NSInteger selectIndex;

@property (nonatomic, strong) NSMutableArray *albumGroups;
/**
 *  加载并显示相册
 */
- (void)setupGroup;

@end
