//
//  HWToolListCell.m
//  双子星云手机
//
//  Created by 余衡武 on 2022/3/21.
//

#import "HWToolListCell.h"

@interface HWToolListCell ()

@property (weak, nonatomic) IBOutlet UIImageView *iconImageView;
@property (weak, nonatomic) IBOutlet UILabel *nameLabel;


@end

@implementation HWToolListCell

- (void)awakeFromNib {
    [super awakeFromNib];
    
    self.nameLabel.textColor = HWFFFFFF80Color;
}

- (void)setModel:(BaseModel *)model {

    _model = model;
    
    self.nameLabel.text = model.name;
    self.iconImageView.image = [UIImage imageNamed:model.iconName];
    
    if (model.isSetUnavailable) {
        self.nameLabel.textColor = [UIColor colorWithHexString:@"FFFFFF" alpha:0.4];
    }else {
        self.nameLabel.textColor = [UIColor colorWithHexString:@"FFFFFF" alpha:0.8];
    }
}

@end
