//
//  PhoneTimeInfoModel.h
//  VclustersGemini
//
//  Created by APPLE on 2020/10/9.
//  Copyright © 2020 APPLE. All rights reserved.
//

#import "SuperModel.h"
#import "BGFMDB.h" //添加该头文件,本类就具有了存储功能.

NS_ASSUME_NONNULL_BEGIN

@interface PhoneTimeInfoModel : SuperModel

/**
 * @brief 云机剩余时长 单位秒S
 */
@property (nonatomic, assign) NSInteger cloudPhoneTime;

/**
 * @brief  赠送时长  单位秒S
 */
@property(nonatomic, assign)NSInteger experienceTime;

/**
 * @brief  弹窗提醒多少天回收云机
 */
@property(nonatomic, assign)NSInteger expirationReminder;

/**
 * @brief  特权信息
 */
@property(nonatomic, copy)NSArray *privilegeList;

/**
 * @brief  云机状态( 0：不存在 1:有效时间 2：有效时间不足 3：过期未回收 )
 */
@property(nonatomic, assign)NSInteger whetherPhoneStatus;


@end

@interface PhoneTimeInfoDataModel : SuperModel

@property(nonatomic, copy)PhoneTimeInfoModel *data;

@end

NS_ASSUME_NONNULL_END
