//
//  couldPhoneFileListModel.h
//  隐私保护
//
//  Created by xd h on 2024/1/8.
//

#import "SuperModel.h"
#import "BGFMDB.h" //添加该头文件,本类就具有了存储功能.

NS_ASSUME_NONNULL_BEGIN

//{
//  "type":"search",
//  "data":{
//      "status":0,          --接口状态 1 失败 0 成功
//      "msg":"xxxxxxx",     --接口状态描述 success 成功 failed失败
//      "list":[
//          "fileType":"xxx",  --文件类型
//          "length":"xxx",    --文件长度
//          "name":"xxx",      --文件名
//          "path":"xxx"       --文件路径
//          "time":1692844579000   --创建文件时间戳 （毫秒）
//      ]
//  }
//}

typedef enum{
    downloadStateWait = 0,
    downloadStateUploading,
    downloadStateSuspend,
    downloadStateFail,
    downloadStateDone,//
}downloadStateType;

@interface couldPhoneFileModel : SuperModel
@property (nonatomic, copy) NSString * fileType;
@property (nonatomic, copy) NSString * path;
@property (nonatomic, copy) NSString * name;
@property (nonatomic, assign) long  length;
@property (nonatomic, assign) long time;

//自定义
@property (nonatomic, assign) BOOL isSelectType;
@property (nonatomic, assign) downloadStateType curDownloadStateType;
@property (nonatomic, assign)  long didDownloadBytes;//已经上传的字节数
@property (nonatomic, assign)  long preDownloadBytes;//已经上传的字节数

@property (nonatomic, assign) NSTimeInterval  preTimeInterval;//计算速度用
@property (nonatomic, assign) NSTimeInterval  curTimeInterval;//计算速度用

- (NSString*)getFileNameFun;
@end

@protocol couldPhoneFileModel;
@interface couldPhoneFileArrModel : SuperModel
@property (nonatomic, strong) NSArray<couldPhoneFileModel>* list;
@end


@interface couldPhoneFileListModel : SuperModel
@property (nonatomic, strong) couldPhoneFileArrModel* data;
@property (nonatomic, copy) NSString * type;
@end

NS_ASSUME_NONNULL_END
