//
//  RecoderManager.h
//  VclustersGemini
//
//  Created by APPLE on 2019/12/23.
//  Copyright © 2019 APPLE. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <VideoToolbox/VideoToolbox.h>
#import <AVFoundation/AVFoundation.h>
NS_ASSUME_NONNULL_BEGIN

@protocol RecoderManagerDelegate <NSObject>

- (void)videoOutPutH264Data:(void *)h264Data dataLenth:(NSInteger)lenth;

@end

@interface RCVideoRecoderManager : NSObject

@property (nonatomic, assign, readonly) BOOL isRecoding;

@property (nonatomic, weak) id<RecoderManagerDelegate> delegate;

- (void)startRecording;

- (void)stopRecording;

- (id)initWithAVCaptureDevicePosition:(AVCaptureDevicePosition)position;

@end

NS_ASSUME_NONNULL_END
